From d28b4a91a0028f4d96069779d9f46d00c3c53121 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Mar 21 2017 09:44:19 +0000
Subject: [PATCH 4/6] Map channels in messages to configured channels


---

diff --git a/hubs/widgets/halp/functions.py b/hubs/widgets/halp/functions.py
index b7f2b88..0c30728 100644
--- a/hubs/widgets/halp/functions.py
+++ b/hubs/widgets/halp/functions.py
@@ -1,4 +1,4 @@
-from __future__ import unicode_literals
+from __future__ import unicode_literals, absolute_import
 
 
 import datetime
@@ -12,6 +12,7 @@ import time
 from jinja2.utils import urlize
 
 from hubs.widgets.caching import CachedFunction
+from .utils import find_hubs_for_msg
 
 
 log = logging.getLogger('hubs.widgets')
@@ -42,20 +43,14 @@ class GetRequests(CachedFunction):
     def should_invalidate(self, message):
         if message["topic"] != self.TOPIC:
             return False
-        hubs = channel_to_hubs(message['msg']['channel'])
-        return bool(set(hubs) & set(self.instance.config["hubs"]))
-
-
-def channel_to_hubs(channel):
-    # TODO: Link the channel to the hubs that use it.
-    return [channel.lstrip("#")]
+        hubs = find_hubs_for_msg(message['msg'])
+        return bool(set(hubs) & set(self.instance.config.get("hubs", [])))
 
 
 def _format_message(raw_message):
     msg = {
         "date": raw_message["msg"]["details"]["time_"],
         "channel": raw_message["msg"]["channel"],
-        "hubs": channel_to_hubs(raw_message["msg"]["channel"]),
         "meeting_topic": raw_message["msg"]["meeting_topic"],
         "text": raw_message["msg"]["details"]["line"],
         "context_url": "%s.log.html#l-%s" % (
diff --git a/hubs/widgets/halp/utils.py b/hubs/widgets/halp/utils.py
new file mode 100644
index 0000000..86a5f00
--- /dev/null
+++ b/hubs/widgets/halp/utils.py
@@ -0,0 +1,17 @@
+from __future__ import unicode_literals
+
+from hubs.models import Hub, HubConfig
+
+
+def find_hubs_for_msg(msg):
+    """
+    Returns the hubs working in the given channel.
+
+    TODO: link meeting channels to the hub using them at that time.
+    """
+    return [
+        h[0] for h in
+        Hub.query.join(HubConfig).filter(
+            HubConfig.chat_channel == msg["channel"]
+        ).values(Hub.name)
+        ]
diff --git a/hubs/widgets/halp/views.py b/hubs/widgets/halp/views.py
index b4ce683..3c992f4 100644
--- a/hubs/widgets/halp/views.py
+++ b/hubs/widgets/halp/views.py
@@ -10,6 +10,7 @@ from hubs.views.utils import get_hub
 from hubs.widgets import registry
 from hubs.widgets.base import WidgetView
 from .functions import GetRequests
+from .utils import find_hubs_for_msg
 
 
 def paginate(values, per_page):
@@ -50,7 +51,7 @@ class BaseView(WidgetView):
 
     def get_context(self, instance, *args, **kwargs):
         return dict(
-            hubs=instance.config["hubs"],
+            hubs=instance.config.get("hubs", []),
             title=self.widget.label,
             )
 
@@ -70,6 +71,9 @@ class DataView(WidgetView):
         data = {"requests": []}
         hubs_filter = flask.request.args.getlist("hubs")
         for req in get_requests():
+            req["hubs"] = find_hubs_for_msg(req)
+            if not req["hubs"]:
+                continue
             req["hub"] = req["hubs"][0]  # Arbitrarily assign the first hub.
             if "hubs" in flask.request.args:
                 # Find which hubs are targeted by this message.
@@ -122,6 +126,9 @@ class SearchView(WidgetView):
         # filter the data
         data = {"requests": []}
         for req in get_requests():
+            req["hubs"] = find_hubs_for_msg(req)
+            if not req["hubs"]:
+                continue
             req["hub"] = req["hubs"][0]  # Arbitrarily assign the first hub.
             if filter_hubs is not None and not set(req["hubs"]) & filter_hubs:
                 continue

